<template>
    <v-app>
        <!-- BEGIN Menu --><!-- TODO: Make it work -->
        <v-app-bar app dark>

        <!-- <v-app-bar-nav-icon @click.stop="drawer = !drawer"></v-app-bar-nav-icon> -->

        <v-toolbar-title>Vigil</v-toolbar-title>

        <v-spacer></v-spacer>

        <v-btn icon>
            <v-icon>fas fa-bell</v-icon>
        </v-btn>

        <v-btn icon to="user">
            <v-icon>fas fa-user-alt</v-icon>
        </v-btn>

        <v-btn icon @click.stop="logout">
            <v-icon>fas fa-sign-out-alt</v-icon>
        </v-btn>
        
        </v-app-bar>

        <!-- <v-navigation-drawer v-model="drawer" dark absolute temporary>

        <v-list nav dense>
            <v-list-item>
                <v-list-item-title>Visualisation des Services</v-list-item-title>
            </v-list-item>

            <v-list-item>
                <v-list-item-title>Visualisation des Sondes</v-list-item-title>
            </v-list-item>

            <v-list-item>
                <v-list-item-title>Administration</v-list-item-title>
            </v-list-item>
        </v-list>

        </v-navigation-drawer> -->
        <!-- END Menu -->

        <!-- BEGIN Main content -->
        <v-content>
            <v-card :elevation="4" class="mainContent">
                <h2 class="connectionTitle">{{ $t("profil") }}</h2>
                <v-form ref="signup">
                    <v-text-field 
                        v-model="user.name" 
                        v-bind:label="$t('username')" 
                        :rules="[rules.required]" 
                        @keyup.enter="submit" 
                        required
                    ></v-text-field>
                    <v-text-field 
                        v-model="user.mail" 
                        v-bind:label="$t('mail')" 
                        :rules="[rules.required, rules.adrMel]" 
                        @keyup.enter="submit" 
                        required
                    ></v-text-field>
                    <v-text-field 
                        v-model="user.refreshRate" 
                        type="number" 
                        v-bind:label="$t('refresh-rate')" 
                        :rules="[rules.required]" 
                        @keyup.enter="submit" 
                        required
                    ></v-text-field>
                    <v-btn color="primary" @click="modifyPass.modal = true">{{ $t('modif-password') }}</v-btn>
                    <v-checkbox
                        v-model="user.notif"
                        v-bind:label="$t('accept-sendMail')"
                    ></v-checkbox>
                </v-form>
                <v-card-actions>
                    <v-btn absolute right bottom color="primary" @click="submit">{{ $t('submit') }}</v-btn>
                    <v-btn absolute left bottom color="normal" @click="cancel">{{ $t('cancel') }}</v-btn>
                </v-card-actions>
            </v-card>

            
            <v-dialog v-model="modifyPass.modal" persistent max-width="50vw">
                <ModifyPassword @exit="closeModal('modifyPass')"/>
            </v-dialog>
        </v-content>
        <!-- END Main content -->
    </v-app>
</template>

<script>
    import ModifyPassword from "@/components/user/ModifyPassword";
    import APIUser from "@/api/UserAPI.js";

    const apiUser = new APIUser();

    export default {
        name: "User",
        components: {
            ModifyPassword,
        },
        data() {
            return {
                user: Object.assign({}, JSON.parse(localStorage.getItem("user"))),
                modifyPass: {
                    modal: false,
                },
                rules: {
                    required: v => !!v || this.$t("required"),
                    adrMel: () => /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/gmi.test(this.user.mail) || this.$t("not-email"),
                },
            };
        },
        methods: {
            async submit() {
                try {
                    if(this.$refs.signup.validate()) {
                        console.log("Submit");
                        let data = await apiUser.updateUser({
                            _id: this.user._id,
                            name: this.user.name,
                            mail: this.user.mail,
                            refreshRate: this.user.refreshRate,
                        });
                        localStorage.setItem("user", JSON.stringify(data.data));
                        this.$noty.success(this.$t("account-changed"));
                        this.$router.push("/");
                    }
                } catch (err) {
                    console.error(`Error has occured : ${err}`);
                }
            },
            cancel() {
                console.log("Cancel");
                this.$router.push("/");
            },
            
            /**
             * Close a modal window
             */
            closeModal(modal) {
                this[modal].modal = false;
                console.log(`Modal window closed : ${modal}`);
            },

            /**
             * Logout a user
             */
            logout() {
                localStorage.clear();
                this.$router.push("/login");
            },
        },
    };
</script>

<i18n>
{
    "en": {
        "profil": "My Profil",
        "password-match": "Passwords must be the same",
        "password-criteria": "Respect all criterias",
        "password-confirm": "Confirm password",
        "not-email": "Please enter a valid mail",
        "accept-sendMail": "Would you like to receive regular mail notifications from Vigil concerning your services and updates ?",
        "modif-password": "Modify my password",
        "account-changed": "Profil modified !",
        "refresh-rate": "Refresh period of the list (in seconds)"
    },
    "fr": {
        "profil": "Mon Profil",
        "password-match": "Les mots de passes doivent correspondre",
        "password-criteria": "Le mot de passe doit respecter les règles suivantes",
        "password-confirm": "Confirmer le mot de passe",
        "not-email": "Veuillez saisir une adresse mail valide",
        "accept-sendMail": "Souhaitez-vous recevoir régulièrement des notifications e-mails de Vigil concernant vos services et d'éventuelles mises à jour ?",
        "modif-password": "Modifer mon mot de passe",
        "account-changed": "Profil modifié !",
        "refresh-rate": "Période de rafraîchissement de la liste (en secondes)"
    }
}
</i18n>